unit App;

{$I define.pp}

interface

uses
 Objects, Drivers,
 Views, Menus, Dialogs;

const

{ TApplication palette entries }

  apColor      = 0;
  apBlackWhite = 1;
  apMonochrome = 2;

{ TApplication palettes }

  CAppColor =
        #$71#$70#$78#$74#$20#$28#$24#$17#$1F#$1A#$31#$31#$1E#$71#$1F +
    #$37#$3F#$3A#$13#$13#$3E#$21#$3F#$70#$7F#$7A#$13#$13#$70#$7F#$7E +
    #$70#$7F#$7A#$13#$13#$70#$70#$7F#$7E#$20#$2B#$2F#$78#$2E#$70#$30 +
    #$3F#$3E#$1F#$2F#$1A#$20#$72#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$17#$1F#$1A#$71#$71#$1E#$17#$1F#$1E#$20#$2B#$2F#$78#$2E#$10#$30 +
    #$3F#$3E#$70#$2F#$7A#$20#$12#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$37#$3F#$3A#$13#$13#$3E#$30#$3F#$3E#$20#$2B#$2F#$78#$2E#$30#$70 +
    #$7F#$7E#$1F#$2F#$1A#$20#$32#$31#$71#$70#$2F#$7E#$71#$13#$38#$00;

  CAppBlackWhite =
        #$70#$70#$78#$7F#$07#$07#$0F#$07#$0F#$07#$70#$70#$07#$70#$0F +
    #$07#$0F#$07#$70#$70#$07#$70#$0F#$70#$7F#$7F#$70#$07#$70#$07#$0F +
    #$70#$7F#$7F#$70#$07#$70#$70#$7F#$7F#$07#$0F#$0F#$78#$0F#$78#$07 +
    #$0F#$0F#$0F#$70#$0F#$07#$70#$70#$70#$07#$70#$0F#$07#$07#$78#$00 +
    #$07#$0F#$0F#$07#$70#$07#$07#$0F#$0F#$70#$78#$7F#$08#$7F#$08#$70 +
    #$7F#$7F#$7F#$0F#$70#$70#$07#$70#$70#$70#$07#$7F#$70#$07#$78#$00 +
    #$70#$7F#$7F#$70#$07#$70#$70#$7F#$7F#$07#$0F#$0F#$78#$0F#$78#$07 +
    #$0F#$0F#$0F#$70#$0F#$07#$70#$70#$70#$07#$70#$0F#$07#$07#$78#$00;

  CAppMonochrome =
        #$70#$07#$07#$0F#$70#$70#$70#$07#$0F#$07#$70#$70#$07#$70#$00 +
    #$07#$0F#$07#$70#$70#$07#$70#$00#$70#$70#$70#$07#$07#$70#$07#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$70#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$70#$00 +
    #$70#$70#$70#$07#$07#$70#$70#$70#$0F#$07#$07#$0F#$70#$0F#$70#$07 +
    #$0F#$0F#$07#$70#$07#$07#$70#$07#$07#$07#$70#$0F#$07#$07#$70#$00;

{ TBackground palette }

  CBackground = #1;

type

{ TBackground object }

  PBackground = ^TBackground;
  TBackground = object(TView)
    Pattern: Char;
    constructor Init(var Bounds: TRect; APattern: Char);
    procedure Draw; virtual;
    function GetPalette: PPalette; virtual;
  end;

{ TDesktop object }

  PDesktop = ^TDesktop;
  TDesktop = object(TGroup)
    Background: PBackground;
    TileColumnsFirst: Boolean;
    constructor Init(var Bounds: TRect);
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitBackground; virtual;
  end;

{ TProgram object }

  { Palette layout }
  {     1 = TBackground }
  {  2- 7 = TMenuView and TStatusLine }
  {  8-15 = TWindow(Blue) }
  { 16-23 = TWindow(Cyan) }
  { 24-31 = TWindow(Gray) }
  { 32-63 = TDialog }

  PProgram = ^TProgram;
  TProgram = object(TGroup)
    constructor Init;
    destructor Done; virtual;
    function CanMoveFocus: Boolean;
    function ExecuteDialog(P: PDialog; Data: Pointer): Word;
    procedure GetEvent(var Event: TEvent); virtual;
    function GetPalette: PPalette; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Idle; virtual;
    procedure InitDesktop; virtual;
    procedure InitMenuBar; virtual;
    procedure InitScreen; virtual;
    procedure InitStatusLine; virtual;
    function InsertWindow(P: PWindow): PWindow;
    procedure PutEvent(var Event: TEvent); virtual;
    procedure Run; virtual;
    procedure SetScreenMode(Mode: Word);
    function ValidView(P: PView): PView;
  end;

{ TApplication object }

  PApplication = ^TApplication;
  TApplication = object(TProgram)
    constructor Init;
    destructor Done; virtual;
  end;

{ Standard menus and status lines }

function StdStatusKeys(Next: PStatusItem): PStatusItem;

const

{ Public variables }

  Application: PProgram = nil;
  Desktop: PDesktop = nil;
  StatusLine: PStatusLine = nil;
  MenuBar: PMenuView = nil;
  AppPalette: Integer = apColor;

implementation

uses Screen, trace;

const
  Pending: TEvent = (What: evNothing);

{ TBackground }

constructor TBackground.Init(var Bounds: TRect; APattern: Char);
 begin
  TView.Init(Bounds);
  GrowMode := gfGrowHiX + gfGrowHiY;
  Pattern := APattern;
 end;

procedure TBackground.Draw;
 var B: TDrawBuffer;
 begin
  MoveChar(B, Pattern, GetColor($01), Size.X);
  WriteLine(0, 0, Size.X, Size.Y, B);
 end;

function TBackground.GetPalette: PPalette;
 const P: string[Length(CBackground)] = CBackground;
 begin GetPalette := @P end;

{ TDesktop object }

constructor TDesktop.Init(var Bounds: TRect);
 begin
  inherited Init(Bounds);
  GrowMode := gfGrowHiX + gfGrowHiY;
  InitBackground;
  if Background <> nil then Insert(Background);
 end;

procedure TDesktop.HandleEvent(var Event: TEvent);
 begin
  TGroup.HandleEvent(Event);
  if Event.What = evCommand then begin
   case Event.Command of
    cmNext: FocusNext(False);
    cmPrev: if Valid(cmReleasedFocus) then Current^.PutInFrontOf(Background);
    else Exit;
   end;
   ClearEvent(Event);
  end;
 end;

procedure TDesktop.InitBackground;
 var R: TRect;
 begin GetExtent(R); New(Background, Init(R, #176)) end;

{ TProgram }

constructor TProgram.Init;
 var R: TRect;
 begin
  Application := @Self;
  InitScreen;
  with MyScreen do R.Assign(0, 0, ScreenWidth, ScreenHeight);
  TGroup.Init(R);
  State := sfVisible + sfSelected + sfFocused + sfModal + sfExposed;
  Options := 0;
  Buffer := PVideoBuf(MyScreen.ScreenBuffer);
  InitDesktop;
  InitStatusLine;
  InitMenuBar;
  if Desktop <> nil then Insert(Desktop);
  if StatusLine <> nil then Insert(StatusLine);
  if MenuBar <> nil then Insert(MenuBar);
 end;

destructor TProgram.Done;
 begin
  if Desktop <> nil then Dispose(Desktop, Done);
  if MenuBar <> nil then Dispose(MenuBar, Done);
  if StatusLine <> nil then Dispose(StatusLine, Done);
  Application := nil;
  inherited Done;
 end;

function TProgram.CanMoveFocus: Boolean;
 begin CanMoveFocus := Desktop^.Valid(cmReleasedFocus) end;

function TProgram.ExecuteDialog(P: PDialog; Data: Pointer): Word;
 var C: Word;
 begin
  ExecuteDialog := cmCancel;
  if ValidView(P) <> nil then begin
   if Data <> nil then P^.SetData(Data^);
   C := Desktop^.ExecView(P);
   if (C <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
   Dispose(P, Done); ExecuteDialog := C;
  end;
 end;

procedure TProgram.GetEvent(var Event: TEvent);
 var R: TRect;
 function ContainsMouse(P: PView): Boolean;
  begin
   ContainsMouse := (P^.State and sfVisible <> 0) and
    P^.MouseInView(Event.Where);
  end;
 begin
  if Pending.What <> evNothing then begin
   Event := Pending;
   Pending.What := evNothing;
  end else begin
   GetMouseEvent(Event);
   if Event.What = evNothing then begin
    GetKeyEvent(Event);
    if Event.What = evNothing then Idle;
   end;
  end;
  if StatusLine <> nil then
    if (Event.What and evKeyDown <> 0) or
      (Event.What and evMouseDown <> 0) and
      (FirstThat(@ContainsMouse) = PView(StatusLine))
     then StatusLine^.HandleEvent(Event);
 end;

function TProgram.GetPalette: PPalette;
 const
  P: array[apColor..apMonochrome] of string[Length(CAppColor)] =
    (CAppColor, CAppBlackWhite, CAppMonochrome);
 begin GetPalette := @P[AppPalette] end;

procedure TProgram.HandleEvent(var Event: TEvent);
 var I: Word; C: Char;
 begin
  if Event.What = evKeyDown then begin
   C := GetAltChar(Event.KeyCode);
   if (C >= '1') and (C <= '9')
    then if Message(Desktop, evBroadCast, cmSelectWindowNum,
        Pointer(Byte(C) - $30)) <> nil
     then ClearEvent(Event);
  end;
  TGroup.HandleEvent(Event);
  if Event.What = evCommand
   then if Event.Command = cmQuit
    then begin EndModal(cmQuit); ClearEvent(Event) end;
 end;

procedure TProgram.Idle;
 begin
  if StatusLine <> nil then StatusLine^.Update;
  if CommandSetChanged then begin
   Message(@Self, evBroadcast, cmCommandSetChanged, nil);
   CommandSetChanged := False;
  end;
 end;

procedure TProgram.InitDesktop;
 var R: TRect;
 begin
  GetExtent(R); Inc(R.A.Y); Dec(R.B.Y);
  New(Desktop, Init(R));
 end;

procedure TProgram.InitMenuBar;
 var R: TRect;
 begin
  GetExtent(R); R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, nil));
 end;

procedure TProgram.InitScreen;
 begin
  if Lo(MyScreen.ScreenMode) <> smMono then begin
   if MyScreen.ScreenMode and smFont8x8 <> 0
    then ShadowSize.X := 1 else ShadowSize.X := 2;
   ShadowSize.Y := 1;
   ShowMarkers := False;
   if Lo(MyScreen.ScreenMode) = smBW80
    then AppPalette := apBlackWhite else AppPalette := apColor;
  end else begin
   ShadowSize.X := 0;
   ShadowSize.Y := 0;
   ShowMarkers := True;
   AppPalette := apMonochrome;
  end;
 end;

procedure TProgram.InitStatusLine;
 var R: TRect;
 begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
   NewStatusDef(0, $FFFF,
    NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
     StdStatusKeys(nil)), nil)));
 end;

function TProgram.InsertWindow(P: PWindow): PWindow;
 begin
  InsertWindow := nil;
  if ValidView(P) <> nil then if CanMoveFocus
   then begin Desktop^.Insert(P); InsertWindow := P end
   else Dispose(P, Done);
 end;

procedure TProgram.PutEvent(var Event: TEvent);
 begin Pending := Event end;

procedure TProgram.Run;
 begin Execute end;

procedure TProgram.SetScreenMode(Mode: Word);
 var R: TRect;
 begin
  HideMouse;
  SetVideoMode(Mode);
  InitScreen;
  with MyScreen do begin
   Buffer := PVideoBuf(ScreenBuffer);
   R.Assign(0, 0, ScreenWidth, ScreenHeight);
  end;
  ChangeBounds(R);
  ShowMouse;
 end;

function TProgram.ValidView(P: PView): PView;
 begin
  ValidView := nil;
  if P <> nil then begin
   if not P^.Valid(cmValid) then begin Dispose(P, Done); Exit end;
   ValidView := P;
  end;
 end;

{ TApplication }

constructor TApplication.Init;
 begin
  InitVideo;
  InitEvents;
  TProgram.Init;
 end;

destructor TApplication.Done;
 begin
  TProgram.Done;
  DoneEvents;
  DoneVideo;
 end;

{ Standard menus and status lines }

function StdStatusKeys(Next: PStatusItem): PStatusItem;
 begin
  StdStatusKeys :=
    NewStatusKey('', kbAltX, cmQuit,
    NewStatusKey('', kbF10, cmMenu,
    NewStatusKey('', kbAltF3, cmClose,
    NewStatusKey('', kbF5, cmZoom,
    NewStatusKey('', kbCtrlF5, cmResize,
    NewStatusKey('', kbF6, cmNext,
    NewStatusKey('', kbShiftF6, cmPrev,
    Next)))))));
 end;

end.
