unit Screen;

{$I define.pp}

interface

const
 screenH0:byte = 25;
 
type
 TScreen = object

  screenMode:word;
  screenWidth:byte;
  screenHeight:byte;
  screenBuffer:^word;
  curX,curY:byte;

  constructor Init;
  destructor Done;
  procedure writeRow(dst:word; var src; len:word);
  procedure drawMouse(show:integer);
  procedure drawCursor(show,BigCursor:boolean);
  procedure moveCursor(x,y:byte);
{
  static void getEvent(TEvent &event);
  static void makeBeep();
  static void putEvent(TEvent &event);
  static void resume();
  static void suspend();
}
 end;

var MyScreen:TScreen;

implementation

uses Crt;

procedure gotoxy1(x,y:byte);
begin
{$IFDEF Arabian}
  gotoxy(MyScreen.ScreenWidth+1-x,y);
{$ELSE}
  gotoxy(x,y);
{$ENDIF}
end;

constructor TScreen.Init;
 begin
  screenWidth := 80; screenHeight := screenH0;
  curX:=screenWidth-1;
  curY:=screenHeight-1;
  GetMem(screenBuffer,screenWidth * screenHeight * SizeOf(word));
 end;

destructor TScreen.Done;
 begin
  FreeMem(screenBuffer,screenWidth * screenHeight * SizeOf(word));
  TextColor(7); TextBackGround(0); 
  writeln('Screen done 0 ...');
  DrawCursor(true,false); clrscr;
  writeln('Screen done 1 ...');
 end;

procedure TScreen.writeRow(dst:word; var src; len:word);
 const BadSet = [chr(7)..chr(13),chr(27)];
 type TWordArr = array[byte] of word;
 var x,y:byte; cnt:byte; w:word; c:char;
 begin if len>0 then begin
  x:=dst mod screenWidth;
  y:=dst div screenWidth;
{$IFNDEF Arabian}
  gotoxy1(x+1,y+1);
{$ENDIF}
  for cnt:=0 to len-1 do begin
{$IFDEF Arabian}
   gotoxy1(x+cnt+1,y+1);
{$ENDIF}
   w:=TWordArr(src)[cnt];
   TextAttr:=w shr 8; c:=chr(w and $FF);
   if c in BadSet then c:='';
{$IFDEF Arabian}
   if (y<ScreenHeight-1) or (x+cnt>0)
{$ELSE}
   if (y<ScreenHeight-1) or (x+cnt<ScreenWidth-1)
{$ENDIF}
    then write(c);
  end;
  gotoxy1(curX+1,curY+1);
 end end;

procedure TScreen.drawCursor(show,BigCursor:boolean);
 begin
  if not show then begin curX:=screenWidth-1; curY:=screenHeight-1 end;
  gotoxy1(curX+1,curY+1);
 end;

procedure TScreen.moveCursor(x,y:byte);
 begin
  curX:=x; curY:=y;
 end;

procedure TScreen.drawMouse(show:integer);
 begin
 end;

end.